
ep=2;
distelec=30; //dist inter electrodes
delec=3; //diametre electrodes
jeuElecIso=0.05;//jeu en rayon entre electrode et isolation
l=20;//largeur boite
hIsole=50;//longueur d'électrode isolée
hContact=50;//longueur d'électrode en contact avec la terre
lElectrode=hIsole+hContact+10;
hBoite=20;



coupex();
//coupey();
//ensemble();


//pour imprimer:
//rotate([180,0,0]) broches();
//rotate([180,0,0])boite();


module coupex()
{
intersection()
{
ensemble();
translate([0,-50,0]) cube([100,100,500],center=true);
}
}

module coupey()
{
intersection()
{
ensemble();
translate([-50,0,0]) cube([100,100,500],center=true);
}
}


module ensemble()
{
translate([0,0,-ep]) boite();
broches();
//electrode
translate([distelec/2,0,-lElectrode+10]) electrode();
translate([-distelec/2,0,-lElectrode+10]) electrode();
}

module broches()
{


//plaque de base
difference()
{
cube([distelec+l,l,ep*2],center=true);
translate([distelec/2,0,0]) cylinder(r=delec/2+jeuElecIso,h=10,center=true,$fn=20);
translate([-distelec/2,0,0]) cylinder(r=delec/2+jeuElecIso,h=10,center=true,$fn=20);
translate([0,0,0]) cylinder(r=1.5,h=10,center=true,$fn=20);
}

//isolation
translate([distelec/2,0,0]) difference()
{
union()
	{
	//isolation cylindre
	translate([0,0,-hIsole]) cylinder(r=delec/2+ep,h=hIsole,center=false,$fn=20);
	//cone base
	translate([0,0,-12+0.2]) cylinder(r2=delec/2+2*ep,r1=delec/2+ep,h=10,center=false,$fn=20);
	//cone
	translate([0,0,-hIsole-10+0.2]) cylinder(r2=delec/2+ep,r1=delec/2+ep/4,h=10,center=false,$fn=20);
	}
translate([0,0,-hIsole-20+1])cylinder(r=delec/2+jeuElecIso,h=hIsole+20,center=false,$fn=20);
}

//isolation
translate([-distelec/2,0,0]) difference()
{
union()
	{
	//isolation cylindre
	translate([0,0,-hIsole]) cylinder(r=delec/2+ep,h=hIsole,center=false,$fn=20);
	//cone base
	translate([0,0,-12+0.2]) cylinder(r2=delec/2+2*ep,r1=delec/2+ep,h=10,center=false,$fn=20);
	//cone
	translate([0,0,-hIsole-10+0.2]) cylinder(r2=delec/2+ep,r1=delec/2+ep/4,h=10,center=false,$fn=20);
	}
translate([0,0,-hIsole-20+1])cylinder(r=delec/2+jeuElecIso,h=hIsole+20,center=false,$fn=20);
}

}


module boite()
{
jeu=0.3;
difference()
{
translate([-(distelec+l+2*ep)/2,-(l+2*ep)/2,0]) cube([distelec+l+2*ep,l+2*ep,hBoite],center=false);
translate([-(distelec+l+jeu*2)/2,-(l+jeu*2)/2,-1]) cube([distelec+l+jeu*2,l+jeu*2,2*ep+1],center=false);
translate([-(distelec+l-ep*2)/2,-(l-ep*2)/2,0]) cube([distelec+l-2*ep,l-2*ep,hBoite-ep],center=false);
//passage cable
translate([distelec,0,hBoite/2]) rotate([0,90,0]) cylinder(r=3,h=20,center=true,$fn=20);
}
//renfort pour vis M3
difference()
{
translate([0,0,hBoite-ep*2]) cube([10,10,6],center=true);
translate([0,0,hBoite-5-ep]) cylinder(r=1.25,h=10,center=true,$fn=20);

}


}

module electrode()
{
cylinder(r=delec/2,h=lElectrode,center=false,$fn=20);
}