#define voltageFlipPin1 6
#define voltageFlipPin2 7
#define adcPinHearthHumidity 4
int flipTimer = 200;




void setSensorPolarity(boolean flip){
  if(flip){
    digitalWrite(voltageFlipPin1, HIGH);
    digitalWrite(voltageFlipPin2, LOW);
  }else{
    digitalWrite(voltageFlipPin1, LOW);
    digitalWrite(voltageFlipPin2, HIGH);
  }
}

double getHhearth(){
  //
  setSensorPolarity(true);
  delay(flipTimer);
  int val1 = analogRead(adcPinHearthHumidity);
  delay(flipTimer);  
  setSensorPolarity(false);
  delay(flipTimer);
  // invert the reading
  int val2 = 1023 - analogRead(adcPinHearthHumidity);
  //all off:
  digitalWrite(voltageFlipPin2, LOW);
  digitalWrite(voltageFlipPin1, LOW);
  
  return (val1 + val2) / 2;
}



