
// fonctions de communications
#include "Arduino.h"
#include "Message.h"


Message::Message()
{
//char* resp = (char*) malloc(sizeof(char)*(_length+1));
//_message=(char*)malloc(sizeof(char)*(maxMessageLenght+1));
_nbVals=0;
}


int Message::readMessage()
{
  int incomingByte=0;
    // read the incoming byte:
  int i=0;
  for(;;) 
    {
    incomingByte = Serial.read();
	
				// say what you got:
				 // Serial.print(i,DEC);
				 // Serial.print(" ");
				 // Serial.print((char)incomingByte);
				 // Serial.print(" ");
				 // Serial.print(incomingByte);
				 // Serial.println("   ");
	
    delay(10);
    if (incomingByte==-1) break;
    if (incomingByte==endChar) break;//until ; 
    if (incomingByte==10) break;//until New Line; 
    if (incomingByte==13) break;//until Carriage Return; 
    if (i==maxMessageLenght-1) 
      {
      //Serial.print("Message too long > ");
      //Serial.println(maxMessageLenght);
	  _nbVals=0;
 	  return -1;
      }
    _message[i]=incomingByte;
    i++;
    }
  _messageLenght=i;
  
	// Serial.print("messageLenght ");
	// Serial.println(_messageLenght, DEC);
	// Serial.print("*");
	// for (int i=0;i<_messageLenght;i++) Serial.print(_message[i]);
	// Serial.print("*");
	// Serial.println();

    readNumValsInMessage();
	
// Serial.print(" nbVals=");
// Serial.println(_nbVals, DEC);
// for (int i=0;i<_nbVals;i++) 
     // {
     // Serial.print("index= ");
     // Serial.print(i, DEC);
     // Serial.print(" tag=");
     // Serial.print(tag(i));
     // Serial.print(" val=");
     // Serial.println(val(i), DEC);
     // }

	return 0;

}





/**
read long values tagged by a char just before 12 23 and 2356 in a form like "n12x23y2356;"
*/
 void Message::readNumValsInMessage()
    {
	_nbVals=0;
	if (_messageLenght==0) return;
    _messageIndex=0;
    int i=0;
    for (;;)
      {
      _tags[i]=_message[_messageIndex];//the tag is only one letter
      _vals[i]=readNumValInMessage();
	  
				// Serial.print("val analysed # ");
				// Serial.println(i, DEC);	  
	  
      if (_messageIndex>=_messageLenght) break;
      i++;
      }
    _nbVals=i+1;
	
				 //Serial.print("nbVals: ");
				 //Serial.println(_nbVals, DEC);

    }
/**
read a number after a letter like "n12"
*/
long Message::readNumValInMessage()
    {
    long val=0;
    
    //explore the number length
    int i=_messageIndex;
    i++; //jump the letter
	
			//Serial.print("numberStart ");
			//Serial.println(i, DEC);

    for (;;) 
      {
      char c=_message[i++];
      if (! (isAFigure(c)||isASign(c))  ) break;
      if (i>=_messageLenght+1) break;
      }
    int numberEnd=i-2;
	
			//Serial.print("numberEnd ");
			//Serial.println(numberEnd, DEC);
    
    //read the number
    int sign=+1;
    for (i=_messageIndex+1;i<=numberEnd;i++)
      {
      char c=_message[i];  
      if (isASign(c))
        {
        sign=signum(c);
//      Serial.print("  sign ");
//      Serial.println(sign, DEC);
        continue;
        }
      int exponent=numberEnd-i;
      long part=(c-48)*p10(exponent);
      val+=part;
//      Serial.print("  exponent ");
//      Serial.print(exponent, DEC);
//      Serial.print("  part ");
//      Serial.println(part, DEC);
      }
      val*=sign;
     _messageIndex=numberEnd+1;//set the cursor 
//    Serial.print("Val ");
//    Serial.println(val, DEC);
    return val;
    }

//max 10^8
long Message::p10(int p)
{
long r;
switch (p){
case 0:
r=1;
break;
case 1:
r=10;
break;
case 2:
r=100;
break;
case 3:
r=1000;
break;
case 4:
r=10000;
break;
case 5:
r=100000;
break;
case 6:
r=1000000;
break;
case 7:
r=10000000;
break;
case 8:
r=100000000;
break;}
return r;
}

boolean Message::isAFigure(char c)
{
return ((c>=48)&&(c<=57));
}

boolean Message::isASign(char c)
{
return ((c==43)||(c==45));
}

int Message::signum(char c)
{
if (c==43) return 1;
else if (c==45) return -1;
else return 0;
}



int Message::nbVals()
{
return _nbVals;

}


long Message::val(int i)
{
return _vals[i];

}

char Message::tag(int i)
{
return _tags[i];

}







