#ifndef Message_h
#define Message_h

#include "Arduino.h"

#define maxMessageLenght 50 //max nb of char in message before CR and LF
#define endChar 59  //ascii code end char for command , ascii code of ; is 59
#define maxNbVals 10 //max 10 long values in a message !!!

class Message
{
  public:
    Message();
	int readMessage();
	long val(int i);
	char tag(int i);
	int  nbVals();
  private:
	char _message[maxMessageLenght];
	char _tags[maxNbVals];
	long _vals[maxNbVals];
	int _messageLenght;
	int _messageIndex;
	int _nbVals;
    void readNumValsInMessage();
	long readNumValInMessage();
	long p10(int p);
	boolean isAFigure(char c);
	boolean isASign(char c);
	int signum(char c);
};



#endif